var gSessionManager_fixer = {
	onLoad: function() {
		// If SessionStore defined which means Session Manager is working
		if (gSessionManager.mSessionStore) {
			try {
				// Get encrypted state
				var encrypted = Application.prefs.getValue("extensions.sessionmanager.encrypt_sessions", false);
			
				// force a master password prompt so we don't waste time if user cancels it
				if (encrypted) gSessionManager.mSecretDecoderRing.encryptString("");

				var sessions = gSessionManager.getSessions();
				sessions.forEach(function(aSession) {
					var file = gSessionManager.getSessionDir(aSession.fileName);
					var state = gSessionManager.readSessionFile(file);
					if (state) 
					{
						if (gSessionManager.mSessionRegExp.test(state))
						{
							var needSave = false;
							state = state.split("\n")
							if (encrypted) state[4] = gSessionManager.decrypt(state[4], true);
							if (state[4].charAt(0) != "{") {
								state[4] = "{" + state[4];
								needSave = true;
							}
							if (state[4].charAt(state[4].length-1) != "}") {
								state[4] = state[4] + "}";
								needSave = true;
							}
							if (needSave) {
								if (encrypted) state[4] = gSessionManager.decryptEncryptByPreference(state[4]);
								state = state.join("\n");
								gSessionManager.writeFile(file, state);
							}
						}
					}
				});
				var liExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				liExtensionManager.uninstallItem("{1280606b-2510-4fe0-97ef-9b5bcefafe30}");
				Application.storage.set("sessionmanager_fixer.done", true);
			}
			// failed to encrypt/decrypt so revert setting
			catch (ex) {
				gSessionManager.cryptError(gSessionManager._string("change_encryption_fail"));
			}
		}
		// uninstall
	}
}
if ((typeof(gSessionManager) != "undefined") && !Application.storage.get("sessionmanager_fixer.done", false)) {
	window.addEventListener("load", gSessionManager_fixer.onLoad, false);
}
else {
	var liExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	liExtensionManager.uninstallItem("{1280606b-2510-4fe0-97ef-9b5bcefafe30}");
}